#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
typedef struct big52ucs_t {
	unsigned short big5;
	long ucs;
} big52ucs_t;
typedef struct composite_t {
	unsigned short big5;
	long ucs[2];
} composite_t;
#include "big52ucs.h"
typedef unsigned short USHORT;
//
//Big5`ɤ϶gԑ
//ꂎ: QY(0 = Qʧ)
//
long pack_big5(const big5)
{
	assert(big5 < 0xffff);

	int h = big5 >> 8;
	int l = big5 & 0xff;
	int failed = 0;

	int packed = -1;
	if (h == 0) {
		return (l > 0x80) ? 0 : l;
	} else {
		if (h < 0x81) {
			failed = 1;
		} else if (h < 0x8e) {
			h = h - 0x81 + 113; // h = 113-125
		} else if (h < 0xa1) {
			h = h - 0x8e + 94; // h = 94-112
		} else if (h <= 0xfe) {
			h = h - 0xa1; // h = 0-93
		} else {
			failed = 3;
		}

		if (l < 0x40) {
			failed += 10;
		} else if (l <= 0x7e) {
			l = l - 0x40; // l = 0-62
		} else if (l < 0xa1) {
			failed += 20; //Big5+δ
		} else if (l <= 0xfe) {
			l = l - 0xa1 + 63; // l = 63-156
		} else {
			failed += 30;
		}

		if (failed) {
			fprintf(stderr, "%#xBig5Χ֮(%d)\n", big5, failed);
			return -1;
		}

		packed = h * 157 + l;
	}

	if (packed >= sizeof(big52ucs) / sizeof(big52ucs[0])) {
		if (packed < 126 * 157) {
			return 0;
		}
		fprintf(stderr, "%d = %#x << 8 | %#x: %#xתĴС%dķΧ֮⡣\n", packed, h, l, big5, sizeof(big52ucs) / sizeof(big52ucs[0]));
		return -1;
	}
	if (big5 != big52ucs[packed].big5) {
		fprintf(stderr, "%d/%d = %#x << 8 | %#x: %#x != %#x\n", packed, sizeof(big52ucs) / sizeof(big52ucs[0]), h, l, big5, big52ucs[packed].big5);
		return -1;
	}

	return big52ucs[packed].ucs;
}

#if 0
int composite_cmp(const composite_t *a, const composite_t *b)
{
  if (a->big5 < b->big5) {
    return -1;
  } else if (a->big5 > b->big5) {
    return 1;
  } else {
    return 0;
  }
}

composite_t *find_composite(const USHORT sjis)
{
	composite_t key;
	key.big5 = big5;
	return (composite_t *)bsearch(&key, composite, sizeof composite / sizeof composite[0], sizeof composite[0], (int(*)(const void *, const void *))composite_cmp);
}
#endif
