#include <assert.h>
#include <stdio.h>
#include <stdlib.h>
typedef struct sjis2ucs_t {
	unsigned short sjis;
	long ucs;
} sjis2ucs_t;
typedef struct composite_t {
	long mbc;
	long ucs[2];
} composite_t;
#include "sjis2ucs.h"
typedef unsigned short USHORT;
//
//եJIS`ɤ϶gԑ
//ꂎ: QY(0 = Qʧ)
//
long pack_sjis(const sjis)
{
	assert(sjis <= 0xffff);

	int h = sjis >> 8;
	int l = sjis & 0xff;
	int failed = 0;

	int packed = -1;
	if (h == 0) {
		packed = l;
	} else {
		if (h < 0x81) {
			failed = 1;
		} else if (h <= 0x9f) {
			h = h - 0x81; // h = 0-30
		} else if (h < 0xe0) {
			failed = 2;
		} else if (h <= 0xfc) {
			h = h - 0xe0 + 31; // h = 31-59
		} else {
			failed = 3;
		}

		if (l < 0x40) {
			failed += 10;
		} else if (l <= 0x7e) {
			l = l - 0x40; // l = 0-62
		} else if (l < 0x80) {
			failed += 20;
		} else if (l <= 0xfc) {
			l = l - 0x80 + 63; // l = 63-187
		} else {
			failed += 30;
		}

		if (failed) {
			fprintf(stderr, "%#xShiftJISΧ֮(%d)\n", sjis, failed);
			return -1;
		}

		packed = h * 188 + l + 256;
	}

	if (packed >= sizeof(sjis2ucs) / sizeof(sjis2ucs[0])) {
		if (packed < 60 * 188 + 256) {
			return 0;
		}
		fprintf(stderr, "%d = %#x << 8 | %#x: %#xתС%dķΧ֮⡣\n", packed, h, l, sjis, sizeof(sjis2ucs) / sizeof(sjis2ucs[0]));
		return -1;
	}
	if (sjis != sjis2ucs[packed].sjis) {
		fprintf(stderr, "%d/%d = %#x << 8 | %#x: %#x != %#x\n", packed, sizeof(sjis2ucs) / sizeof(sjis2ucs[0]), h, l, sjis, sjis2ucs[packed].sjis);
		return -1;
	}

	return sjis2ucs[packed].ucs;
}

int composite_cmp(const composite_t *a, const composite_t *b)
{
  if (a->mbc < b->mbc) {
    return -1;
  } else if (a->mbc > b->mbc) {
    return 1;
  } else {
    return 0;
  }
}

composite_t *find_sjis_composite(const sjis)
{
	composite_t key;
	key.mbc = sjis;
	return (composite_t *)bsearch(&key, composite, sizeof composite / sizeof composite[0], sizeof composite[0], (int(*)(const void *, const void *))composite_cmp);
}
